import OFS.SimpleItem
import Globals

from Products.PageTemplates.PageTemplateFile import PageTemplateFile

# The self parameter of the factory method is the parent folder.
manage_addBarForm = PageTemplateFile("www/Bar_add", globals())
def manage_addBar(self, id, title, REQUEST=None):
		"Create a Bar and add it to its parent's folder"

		bar = Bar(id, title)
		self._setObject(id,bar)
		if REQUEST is not None:
				return self.manage_main(self,REQUEST)

class Bar(OFS.SimpleItem.SimpleItem):
	"A non-folderish Bar object."

	def __init__(self,id,title):
		self.id = id
		self.title = title

	__ac_permissions__ = (
		('View management screens',('manage_main',)),
		('View',('index_html',)),
		)

	manage_options=(
		{'label':'Properties','action':'manage_main'},
		{'label':'View','action':'index_html'},
		) + OFS.SimpleItem.SimpleItem.manage_options

	index_html = PageTemplateFile("www/Bar_view", globals())

	manage_main = PageTemplateFile("www/Bar_edit", globals())

	def manage_editBar(self,title,REQUEST=None):
		"Edit Bar properties"
		self.title = title

		if REQUEST is not None:
			return Globals.MessageDialog(
				title='Saved',
				message='Changes to <strong>%s</strong> were saved.' % self.id,
				action='manage_main',
				)

Globals.default__class_init__(Bar)
