import OFS
from AccessControl import ClassSecurityInfo
from Globals import InitializeClass
import os, urllib
from DateTime import DateTime
from Products.CMFDefault.DublinCore import DefaultDublinCoreImpl
from Products.CMFCore.PortalContent import PortalContent
		
from Products.PageTemplates.PageTemplateFile import PageTemplateFile
import Bar
from Products.CMFCore.WorkflowCore import WorkflowAction, afterCreate

# Import permission names
from Products.CMFCore import CMFCorePermissions
import FooPermissions

# Factory type information -- makes Events objects play nicely
# with the Types Tool (portal_types)
factory_type_information = (
	{ 'id': 'Foo',
	  'content_icon':'foo.gif',
	  'meta_type': 'CMFFoo',
	  'description': ('Foos are objects for use as folders'),
	  'product':'FolderishProductDemo',
	  'factory': 'manage_addFoo',
	  'immediate_view': 'Foo_edit',
	  'actions':({'id':'view',
				 'name': 'View',
				 'action':'Foo_view',
				 'permissions': (CMFCorePermissions.View,)},
				{'id': 'edit',
				 'name': 'Edit',
				 'action': 'Foo_edit',
				 'permissions': (FooPermissions.ChangeFoos,)},
	  ),						# End Actions
	},
	)




# The self parameter of the factory method is the parent folder.
manage_addFooForm = PageTemplateFile("www/Foo_add", globals())
def manage_addFoo(self
				  , id
				  , title=''
				  , REQUEST=None):
	"Create a Foo and add it to its parent's folder."

	catalogus = Foo(id, title)
	self._setObject(id,catalogus)
	
	
	if REQUEST is not None:
		afterCreate(self.this().getOb(id))

# You may want to inherit from more objects to get more functionality.
# Look at lib/python/OFS/Folder.py and inherit from the same objects 
# like Folder does.
class Foo(OFS.ObjectManager.ObjectManager, OFS.SimpleItem.Item, PortalContent, DefaultDublinCoreImpl):
	"""
	A folderish Foo, that can contain Foo's and Bar's.
	"""
	meta_type= 'CMFFoo'
	effective_date = expiration_date = None
	_isDiscussable = 1
	# Declarative security
	security = ClassSecurityInfo()
	security.declareObjectProtected(CMFCorePermissions.View)
	
	def __init__(self
				 ,id
				 ,title= ''):
		DefaultDublinCoreImpl.__init__(self)
		self.id = id
		self.setTitle(title)
	
	security.declareProtected(FooPermissions.ChangeFoos, 'edit')
	def manage_editProperties(self,title,REQUEST=None):
		"Edit Foo properties"
		self.title = title

		if REQUEST is not None:
			return Globals.MessageDialog(
				title='Saved',
				message='Changes to <strong>%s</strong> were saved.' % self.id,
				action='manage_main',
				)
	security.declareProtected(FooPermissions.ChangeFoos, 'add bar')
	def addBar(self,REQUEST):
		"Adds a cursus to a catalogus"
		Bar.manage_addBarForm(REQUEST)

	addFooForm = manage_addFooForm
	addBarForm = Bar.manage_addBarForm

	security.declareProtected(FooPermissions.ChangeFoos, 'all meta types')	
	def all_meta_types(self):
		"""
		Return all meta types addable to this catalog. The ZMI uses
		this method (originally defined in ObjectManager) to populate
		the list of classes in the "Add object" menu.
		"""

		# return tuple of dictionaries
		return ( {'name':'Foo',
			 'action':'manage_addProduct/FolderishProductDemo/addFooForm'},
				 { 'name':'Bar',
			 'action':'manage_addProduct/FolderishProductDemo/addBarForm'})

# Intialize the Event class, setting up security.
InitializeClass(Foo)
